
import java.util.ArrayList;
import java.util.Scanner;

public class Pariohjelmointi {

    public static void main(String[] args) {
        // Seitsemännessä pariohjelmoinnissa pohditaan parin kanssa ratkaisua
        // seitsemänne osion viimeiseen tehtävään, eli Unoon.
        
        // Ei haittaa vaikket olisi tehnyt Uno-tehtävää vielä. Lukekaa kuitenkin
        // ennen tämän tehtävän aloittamista Uno-tehtävän tehtävänanto :).
        
        // Pariohjelmoinnin tehtävänanto löytyy osoitteesta
        // https://tinyurl.com/pariohjelmointi7
        
        
        Scanner lukija = new Scanner(System.in);

        ArrayList<Pelaaja> pelaajat = new ArrayList<>();
        pelaajat.add(new TekstipohjainenPelaaja(lukija, "eka"));
        pelaajat.add(new TekstipohjainenPelaaja(lukija, "toka"));

        // Tekoälypelaaja lisätään peliin kun poistat seuraavat kommentit:
//        pelaajat.add(new Tekoalypelaaja());

        Pistetilanne pistetilanne = new Pistetilanne(pelaajat.size());
        Uno uno = new Uno(pistetilanne, pelaajat);

        int aloittajanIndeksi = 0;

        while (true) {

            System.out.println("");
            System.out.println("");
            System.out.println("Aloitetaan! ");

            uno.pelaaKierros(aloittajanIndeksi);

            if (pistetilanne.onkoVoittaja()) {
                break;
            }

            aloittajanIndeksi++;
            aloittajanIndeksi %= pelaajat.size();

            uno.tulostaPistetilanne();

            System.out.println("");
            System.out.println("Peli jatkuu! Seuraava kierros edessä...");
        }

        System.out.println("");
        System.out.println("Peli loppui -- voittaja: " + pelaajat.get(pistetilanne.voittajanIndeksi()));
        System.out.println("Loppupisteet: ");
        uno.tulostaPistetilanne();
    }

}
